package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.vehicle_rent;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "VEHICLE_RENT".
*/
public class vehicle_rentDao extends AbstractDao<vehicle_rent, Long> {

    public static final String TABLENAME = "VEHICLE_RENT";

    /**
     * Properties of entity vehicle_rent.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Provinsi_id = new Property(1, String.class, "provinsi_id", false, "PROVINSI_ID");
        public final static Property Unit = new Property(2, String.class, "unit", false, "UNIT");
        public final static Property Car = new Property(3, String.class, "car", false, "CAR");
        public final static Property Midle_bus = new Property(4, String.class, "midle_bus", false, "MIDLE_BUS");
        public final static Property Big_bus = new Property(5, String.class, "big_bus", false, "BIG_BUS");
    };


    public vehicle_rentDao(DaoConfig config) {
        super(config);
    }
    
    public vehicle_rentDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"VEHICLE_RENT\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"PROVINSI_ID\" TEXT," + // 1: provinsi_id
                "\"UNIT\" TEXT," + // 2: unit
                "\"CAR\" TEXT," + // 3: car
                "\"MIDLE_BUS\" TEXT," + // 4: midle_bus
                "\"BIG_BUS\" TEXT);"); // 5: big_bus
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"VEHICLE_RENT\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, vehicle_rent entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String provinsi_id = entity.getProvinsi_id();
        if (provinsi_id != null) {
            stmt.bindString(2, provinsi_id);
        }
 
        String unit = entity.getUnit();
        if (unit != null) {
            stmt.bindString(3, unit);
        }
 
        String car = entity.getCar();
        if (car != null) {
            stmt.bindString(4, car);
        }
 
        String midle_bus = entity.getMidle_bus();
        if (midle_bus != null) {
            stmt.bindString(5, midle_bus);
        }
 
        String big_bus = entity.getBig_bus();
        if (big_bus != null) {
            stmt.bindString(6, big_bus);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public vehicle_rent readEntity(Cursor cursor, int offset) {
        vehicle_rent entity = new vehicle_rent( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // provinsi_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2), // unit
            cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3), // car
            cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4), // midle_bus
            cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5) // big_bus
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, vehicle_rent entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setProvinsi_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setUnit(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
        entity.setCar(cursor.isNull(offset + 3) ? null : cursor.getString(offset + 3));
        entity.setMidle_bus(cursor.isNull(offset + 4) ? null : cursor.getString(offset + 4));
        entity.setBig_bus(cursor.isNull(offset + 5) ? null : cursor.getString(offset + 5));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(vehicle_rent entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(vehicle_rent entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
